CleanBattlemap = CreateFrame("Frame");
CBMTicker = nil;
BattlemapScale = 1.0;
BattlemapPinSize = 30;
local tile = 0;
local width = 0;
local top = 0;
local pinsSet = false;
local CleanBattlemapEvents = {}
BattlefieldMap_LoadUI()

function DGCBM()
  BattlefieldMapFrame:Show();
  CleanBattlemap_FixMap();
end

function CleanBattleMap_IsBadTile(xOfs)
  tile = math.floor(math.floor(xOfs) / width + 0.5);
  return tile == 3 or tile == 0;
end

function CleanBattlemap_FixMap()
  --CleanBattlemap_CalculateGrid();
  width = 256;
  for k,v in pairs ({BattlefieldMapFrame.ScrollContainer.Child:GetChildren()}) do
    for k2, v2 in pairs({v:GetRegions()}) do
      local _, _, _, xOfs, yOfs = v2:GetPoint();
      if(xOfs ~= nil) then
        if(CleanBattleMap_IsBadTile(xOfs)) then
          v2:Hide();
        else
          v2:Show();
        end
      end
    end
  end
  BattlefieldMapFrame.BorderFrame.CloseButton:Hide()
  BattlefieldMapFrame.BorderFrame.CloseButtonBorder:Hide()
  BattlefieldMapFrame.BorderFrame.TopLeft:Hide()
  BattlefieldMapFrame.BorderFrame.TopRight:Hide()
  BattlefieldMapFrame.BorderFrame.BottomLeft:Hide()
  BattlefieldMapFrame.BorderFrame.BottomRight:Hide()
  BattlefieldMapFrame.BorderFrame.Bottom:Hide()
  BattlefieldMapFrame.BorderFrame.Top:Hide()
  BattlefieldMapFrame.BorderFrame.Left:Hide()
  BattlefieldMapFrame.BorderFrame.Right:Hide()
  BattlefieldMapFrame:SetScale(BattlemapScale);
  BattlefieldMapFrame:Show();
  if(CleanBattlemap_HasLeatrixMaps()) then
    CleanBattlemap_SetPins();
  end
end

function CleanBattlemap_ToggleTicker()
  if(not CleanBattlemap_PlayerInBG()) then
    if(CBMTicker) then
      CBMTicker:Cancel();
    end
    return;
  end
  if(CBMTicker == nil) then
    print("TIGGER");
    CBMTicker = C_Timer.NewTicker(0.1, CleanBattlemap_SetPins);
  end
end

function CleanBattlemap_CalculateGrid()
  if(width ~= 0) then return end
  for k,v in pairs ({BattlefieldMapFrame.ScrollContainer.Child:GetChildren()}) do
    for k2, v2 in pairs({v:GetRegions()}) do
      local _, _, _, xOfs, yOfs = v2:GetPoint();
      if(xOfs ~= nil) then
        xOfs = math.floor(xOfs + 0.5);
        if(xOfs > 0) then
          width = xOfs;
          print(width);
          return;
        end
      end
    end
  end
end

function CleanBattlemapEvents:ZONE_CHANGED_NEW_AREA(...)
  if(CleanBattlemap_PlayerInBG()) then
    CleanBattlemap_FixMap();
  end
end

function CleanBattlemapEvents:AREA_SPIRIT_HEALER_IN_RANGE(...)
  if(CleanBattlemap_PlayerInBG()) then
    CleanBattlemap_FixMap();
  end
end

function CleanBattlemapEvents:PLAYER_LOGIN(...)
  if(CleanBattlemap_PlayerInBG()) then
    CleanBattlemap_FixMap();
  end
end

function CleanBattlemapEvents:RAID_ROSTER_UPDATE(...)
  if(CleanBattlemap_PlayerInBG()) then
    CleanBattlemap_FixMap();
  end
end

function CleanBattlemapEvents:GROUP_ROSTER_UPDATE(...)
  if(CleanBattlemap_PlayerInBG()) then
    CleanBattlemap_FixMap();
  end
end

function CleanBattlemap_PlayerInBG()
  local z = C_Map.GetBestMapForUnit("player");
  return z == 1460 or z == 1461
end

function CleanBattlemap_HasLeatrixMaps()
  return LeaMapsDB ~= nil;
end

function CleanBattlemap_SetPins()
      if(pinsSet) then return end
			local BattlefieldMapUnitPin, BattlefieldMapUnitPinSizes
			local partyTexture = "Interface\\AddOns\\Leatrix_Maps\\Leatrix_Maps_Icon.blp"
			for pin in BattlefieldMapFrame:EnumeratePinsByTemplate("GroupMembersPinTemplate") do
				BattlefieldMapUnitPin = pin
				BattlefieldMapUnitPinSizes = pin.dataProvider:GetUnitPinSizesTable()
  			--BattlefieldMapUnitPin:SetPinSize("party", BattlemapPinSize)
  			--BattlefieldMapUnitPin:SetPinSize("raid", BattlemapPinSize)
  			BattlefieldMapUnitPinSizes.player = BattlemapPinSize * 0.8;
  			BattlefieldMapUnitPinSizes.party = BattlemapPinSize * 0.9;
  			BattlefieldMapUnitPinSizes.raid = BattlemapPinSize * 0.75;
  			--BattlefieldMapUnitPinSizes:SynchronizePinSizes()
				--BattlefieldMapUnitPinSizes = { player = BattlemapPinSize * 1.25, party = BattlemapPinSize, raid = BattlemapPinSize * 0.75};
				BattlefieldMapUnitPin:SetPinTexture("raid", partyTexture)
				BattlefieldMapUnitPin:SetPinTexture("party", partyTexture)
  			BattlefieldMapUnitPin:SetAppearanceField("party", "useClassColor", true)
  			BattlefieldMapUnitPin:SetAppearanceField("raid", "useClassColor", true)
				hooksecurefunc(BattlefieldMapUnitPin, "UpdateAppearanceData", function(self)
          self:SetPinSize("party", BattlemapPinSize * 0.8)
          self:SetPinSize("raid", BattlemapPinSize * 0.8)
          self:SetPinSize("player", BattlemapPinSize * 0.6)
					self:SetPinTexture("raid", partyTexture)
					self:SetPinTexture("party", partyTexture)
				end)
        break;
			end
      pinsSet = true;
      --CleanBattlemap_ToggleTicker();
end

CleanBattlemap:SetScript("OnEvent", function(self, event, ...)
  CleanBattlemapEvents[event](self, ...);
end);
for k, v in pairs(CleanBattlemapEvents) do
  CleanBattlemap:RegisterEvent(k);
end

local function CleanBattlemap_Command(msg, editbox)
  msg = strlower(msg);
  local _, _, cmd, args = string.find(msg, "%s?(%w+)%s?(.*)")
  if(cmd == "scale" or cmd == "pin") then
    local size = tonumber(args);
    if(cmd == "scale") then
      if(size ~= nil) then
        print("Scale set to " .. size);
        BattlemapScale = size;
        if(CleanBattlemap_PlayerInBG()) then
          CleanBattlemap_FixMap();
        end
      else
        print("Scale must be set to a number!");
      end
    else
      if(size ~= nil) then
        print("Pin size set to " .. size);
        BattlemapPinSize = size;
        pinsSet = false;
      else
        print("Pin size must be set to a number!");
      end
    end
  else
    print("Command usage: /cbm scale|pin n");
    print("'/cbm scale x' - currently: " .. BattlemapScale);
    print("'/cbm pin n' - currently: " .. BattlemapPinSize);
  end
  if(CleanBattlemap_PlayerInBG()) then
    CleanBattlemap_FixMap();
  end
end


SLASH_CLEANBATTLEMAP1, SLASH_CLEANBATTLEMAP2 = '/cleanbattlemap', '/cbm'

SlashCmdList["CLEANBATTLEMAP"] = CleanBattlemap_Command;
